' Dieses Script zeichnet Abmeldevorgnge auf den Clients auf.
' Es wird eine in eine lokale Log Datei auf dem Client und eine zentrale Log Datei auf einer Serverfreigabe geschrieben.
' Sind die Log-Dateien nicht vorhanden, werden sie erstellt.
' Die Benutzer mssen auf die Dateien schreibenden Zugriff haben.
' Kopieren sie das Script in die netlogon-Freigabe ihres Anmeldeservers.
' Passen sie den lokalen Pfad und die zentrale Serverfreigabe an (file1 und file2).
' Das Script wird per GPO als Anmeldescript des Benutzers ausgefuehrt.

' Standalone Cliets:
' Script in den RUN Key von HKLM schreiben
' damit es bei jedem Start ausgefuehrt wird
' AddRun        

Option Explicit 
Dim Text, pre, folder1, file1, file2, file3, file4
Dim WshNetwork         ' object variable

'************ ANPASSUNGEN - BITTE ANPASSEN! *****************************************************************************

'************ lokalen Pfad und lokale Log Datei auf LW C:  *************
folder1 = "C:\temp"	' Folder of local log file
file1 = "UserLog.txt"   ' local log file name
'************ Ende lokalen Pfad und lokale Log Datei auf LW C:  *************

'************ Pfad der zentralen Log Datei fr Computer, User, Datum, Die Verzeichnisse MSSEN existieren!!! *************
file2 = "\\server\LOGS\User-Login-Logout-Monitor\Computer\"
file3 = "\\server\LOGS\User-Login-Logout-Monitor\User\"
file4 = "\\server\LOGS\User-Login-Logout-Monitor\Date\"
'************ ENDE *** Die zentralen Freigaben und Verzeichnisse MSSEN existieren!!!*************

'************ ENDE ANPASSUNGEN  *****************************************************************************************



         

' Anlegen eines neuen WshNetwork Objekts zum Zugriff auf die Netzwerkeigenschaften
Set WshNetwork = WScript.CreateObject("WScript.Network")



' Zusammenstellung des Testes fuer das Protokoll
Text = "LOGIN:"& vbTab & WshNetwork.UserName & vbTab & date & vbTab & time & vbTab & WshNetwork.ComputerName & vbTab & WshNetwork.UserDomain


AddLocalLog (Text)           'schreibt eine lokale Log-Datei
AddLog1 (Text)          'schreibt eine Log-Datei in eine zentrale Protokoll Freigabe 
AddLog2 (Text)          'schreibt eine Log-Datei in eine zentrale Protokoll Freigabe 
AddLog3 (Text)          'schreibt eine Log-Datei in eine zentrale Protokoll Freigabe 

' entfernen sie die Kommentarzeichen zur Anzeige des Protokolltexts am Desktop
'WScript.Echo Text        ' show result

WScript.Quit()






'######################## Funktionen #############################################################################



'######## Script in den RUN Key von HKLM schreiben damit es bei jedem Start ausgefuehrt wird ###########


'Sub AddRun()
'# Script in den RUN Key von HKLM schreiben
'# damit es bei jedem Start ausgefuehrt wird
'DIM Root, key, valname, Command
'Dim WshShell
'
' Root = "HKEY_LOCAL_MACHINE"
' key = "\Software\Microsoft\Windows\CurrentVersion\Run\"
' valname = "UserLog"
' Command = WScript.ScriptFullName
' Set WshShell = WScript.CreateObject("WScript.Shell")
' WSHShell.RegWrite Root+Key+valname, Command, "REG_SZ"
'End Sub

'######### Ende AddRun()



'********************* LOG lokale Log Datei ******************************

Sub AddLocalLog (txt)

Const ForAppending = 8           ' Append mode
Dim fso, fi                      ' object variable

' Anlegen eines Dateisystem Objekts
 Set fso = CreateObject("Scripting.FileSystemObject")

 If NOT (FSO.FolderExists(folder1)) Then
    FSO.CreateFolder(folder1)
 End If
 
 
' Datei oeffnen oder eine neue Datei erstellen
 Set fi = fso.OpenTextFile(folder1 + "\" + file1, ForAppending, true)

 fi.WriteLine (txt)              ' append log
 Set fi = Nothing


End Sub

'********************* Ende LOG lokale Log Datei ******************************




' ********************** log ComputerName **********************
Sub AddLog1 (txt)
pre = WshNetworK.ComputerName
' WScript.Echo pre

Const ForAppending = 8           ' Append mode
Dim fso, fi                      ' object variable

' Anlegen eines Dateisystem Objekts
 Set fso = CreateObject("Scripting.FileSystemObject")
  file2 = file2 + pre & ".txt" 
' Datei oeffnen oder eine neue Datei erstellen
 Set fi = fso.OpenTextFile(file2, ForAppending, true)

 fi.WriteLine (txt)              ' append log
 Set fi = Nothing
End Sub

' ********************** Ende log ComputerName **********************'######### Ende AddLog1()




' ********************** log UserName **********************

Sub AddLog2 (txt)

pre = WshNetworK.UserName
' WScript.Echo pre

Const ForAppending = 8           ' Append mode
Dim fso, fi                      ' object variable

' Anlegen eines Dateisystem Objekts
 Set fso = CreateObject("Scripting.FileSystemObject")

file3 = file3 + pre & ".txt"   

' Datei oeffnen oder eine neue Datei erstellen
 Set fi = fso.OpenTextFile(file3, ForAppending, true)

 fi.WriteLine (txt)              ' append log
 Set fi = Nothing
End Sub

' ********************** Ende log UserName **********************






' ********************** log Datum **********************

Sub AddLog3 (txt)

'pre = WshNetworK.Date
' WScript.Echo pre

Const ForAppending = 8           ' Append mode
Dim fso, fi                      ' object variable

' Anlegen eines Dateisystem Objekts
 Set fso = CreateObject("Scripting.FileSystemObject")
  file4 = file4 & date & ".txt"   
' Datei oeffnen oder eine neue Datei erstellen
 Set fi = fso.OpenTextFile(file4, ForAppending, true)

 fi.WriteLine (txt)              ' append log
 Set fi = Nothing
End Sub


' ********************** ENDE log Datum **********************


'*************************************************
'***         End -> WSH-VBScript               ***
'*************************************************
