@echo off
goto BEGINN
::==============================================================================
::------------------------------------------------------------------------------
:: getMonitorType - Monitormodell ermitteln - v. 1.1   - Juni 2011 
:: -----------------------------------------------------------------------------
::
:: Info: IT-Regionalbetreuer Vlbg. - Helmut Pajnik
::------------------------------------------------------------------------------
:: Diese Batch ermittelt das Monitormodell mit devcon.exe
:: Das Ergebnis wird angezeigt
:: -----------------------------------------------------------------------------
:: --Alternative unter Windows --
:: 
:: Gertemanger oeffnen und z.B. das Monitormodell auswhlen 
:: - Eigenschaften der Monitore 
:: - unter Details die Gerteinstanzkennung auswaehlen.
::   (ergibt z.B: DISPLAY\MAX077B\4&3B42C36E&0&80861100&00&02
::         d.h:    DISPLAY
::                 MAX077B  = Modellnummer
::                 
::==============================================================================




::==============================================================================
:BEGINN
::
cls
echo --INFO---------------------------------------------------------------
echo Diese Batch ermittelt das angeschlossene Monitormodell des PCs.
echo.  (verwendet devcon.exe und benoetigt Administratorrechte)
echo - starten mit -- ALS ADMINISTRATOR AUSFUEHREN - bei Win7 wegen UAC 
echo.- oder besser -- in einer Administrator - cmd.exe
echo.  !!! Andernfalls erscheint keine Info zum Monitor !!!
echo.         
echo Remoteaufruf mit Parameter: z.B: getMonitorType PC15
echo.                                 zeigt Monitormodell von PC15
rem echo.
echo --INFO-ENDE---------------------------------------------------------- 
echo.
::
::==============================================================================
::------------------------------------------------------------------
::--- Initialisierung-----------------------------------------------
::------------------------------------------------------------------
::
set STARTPATH=%~dp0
if %STARTPATH:~-1%==\ set STARTPATH=%STARTPATH:~0,-1%
rem Pfad sichern und ev.vorhandenen Backslash wegschneiden

if /i %PROCESSOR_ARCHITECTURE%==x86   set DEVCONPROG=devcon-i86.exe
if /i %PROCESSOR_ARCHITECTURE%==amd64 set DEVCONPROG=devcon-amd64.exe 
if /i %PROCESSOR_ARCHITECTURE%==IA64  goto :EOF
::
rem --------
rem x86   -- 32bit-Betriebssystem (Intel und AMD)
rem amd64 -- 64bit-Betriebssystem (Intel und AMD)
rem ia64  -- 64bit-Betriebssystem (Itanium Prozessor)
::
::
::==============================================================================
::



set MYPC=SELF
if not "%1"=="" set MYPC=%1
echo Ermittle angeschlossenen Monitor

if %MYPC%==SELF (
echo auf diesem PC: %COMPUTERNAME%
  "%STARTPATH%\%DEVCONPROG%" hwids =MONITOR|find /i "monitor"|find /i /v "Name"
) else (
echo auf Remote-PC: %MYPC%: 
echo Natuerlich werden auf dem angegebenen PC entsprechende RECHTE benoetigt.
echo.
  "%STARTPATH%\%DEVCONPROG%" -m:\\%1 hwids =MONITOR |find /i "monitor"|find /i /v "Name"
)

echo.
echo (Falls hier kein Monitor angezeigt wird fehlen Administratorrechte!)
echo.
pause